#ifndef _INCLUDED_Fragment_H
#define _INCLUDED_Fragment_H

#include <Foundation/NSObject.h>
#include <Foundation/NSGeometry.h>

@class NSImage;

@interface Fragment : NSObject
{
    NSRect _scene;
    float _scale;
    int _orig_rotation;
    int _rotation;
}

+ (id) fragmentWithScene: (NSRect) scene;
+ (id) fragmentWithScene: (NSRect) scene
                   scale: (float) scale
                rotation: (int) degrees;
+ (id) fragmentWithImage: (NSImage *) image;
+ (id) fragmentWithFragment: (Fragment *) fragm;

- (id) init;
- (id) initWithScene: (NSRect) scene;
- (id) initWithScene: (NSRect) scene
               scale: (float) scale
            rotation: (int) degrees;
- (id) initWithImage: (NSImage *) image;
- (id) initWithFragment: (Fragment *) fragm;

- (NSRect) scene;
- (void) setScene: (NSRect) scene;
- (float) scale;
- (void) setScale: (float) scale;
- (int) rotation;
- (void) setRotation: (int) degrees;

- (void) rotateByDegrees: (float) degrees;
- (id) restoreOriginalState;

@end // @interface Fragment

#endif // _INCLUDED_Fragment_H
