#include "PHGeometry.h"
#include <AppKit/NSAffineTransform.h>

//#define MIN(x, y) (((x) < (y)) ? (x) : (y))
//#define MAX(x, y) (((x) < (y)) ? (y) : (x))
#define DISTANCE(x, y) ( ((x) < (y)) ? ((y) - (x)) : ((x) - (y)) )

NSPoint PHMovePoint(NSPoint pt, float dx, float dy)
{
    pt.x += dx;
    pt.y += dy;
    return pt;
}

NSPoint PHMoveOrigin(NSPoint pt, NSPoint delta_origin)
{
    pt.x -= delta_origin.x;
    pt.y -= delta_origin.y;
    return pt;
}

NSRect PHRectFromPoints(NSPoint a, NSPoint b)
{
    return NSMakeRect(MIN(a.x, b.x),
                      MIN(a.y, b.y),
                      DISTANCE(a.x, b.x),
                      DISTANCE(a.y, b.y));
}

float PHDistance(NSPoint a, NSPoint b)
{
    return MAX( DISTANCE(a.x, b.x), DISTANCE(a.y, b.y) );    
}

NSAffineTransform * PHReverseTransform(NSAffineTransform * xform)
{
    NSAffineTransform * reverse = [xform copy];
    [reverse invert];

    return AUTORELEASE(reverse);
}
